
/*// Criar Lista
$(document).on("click", ".botao_criar_lista", function()
{
$.ajax({
url: '/app/elements/functions/ajax.php',
type: 'POST',
data: {"ajax":"criar_lista_modal"},
cache: false,
success: function(response){
$('#criar_lista_modal .modal-content').html(response);
}
});
});

// Editar Lista
$(document).on("click", '.botao_editar_lista', function()
{
var tarestadoid = $(this).data('id');
$.ajax({
url: '/app/elements/functions/ajax.php',
type: 'POST',
data: {"ajax": "editar_lista_modal", "tarestadoid": tarestadoid },
cache: false,
success: function(response){
$('#editar_lista_modal .modal-content').html(response);
}
});
});

// Eliminar Lista
$(document).on('click', '.botao_eliminar_lista', function()
{
var nomeestado = $(this).data('nomeestado');
var tarestadoid = $(this).data('tarestadoid');
$.ajax({
url: '/app/elements/functions/ajax.php',
type: 'POST',
data: {"ajax":"eliminar_lista_modal", "nomeestado":nomeestado, "tarestadoid":tarestadoid },
cache: false,
success: function(response){
$('#eliminar_lista_modal .modal-dialog').html(response);
}
});
});*/

// Botão Eliminar Lista Erro
$(document).on('click', '.botao_eliminar_lista_erro', function()
{
  var nomeestado = $(this).data('nomeestado');
  var tarestadoid = $(this).data('tarestadoid');
  $.ajax({
    url: '/app/elements/functions/ajax.php',
    type: 'POST',
    data: {"ajax":"eliminar_lista_erro", "nomeestado":nomeestado, "tarestadoid":tarestadoid },
    cache: false,
    success: function(response){
      $('#eliminar_lista_erro .modal-dialog').html(response);
    }
  });
});

// Editar Tarefa
$(document).on("click", ".botao_editar_tarefa", function()
{
  var tarefaid = $(this).data('id');
  var user = $(this).data('user');
  console.log("tarefaid :" + tarefaid);
  $.ajax({
    url: '/app/elements/functions/ajax.php',
    type: 'POST',
    data: {"ajax":"editar_tarefa_modal", "tarefaid":tarefaid, "user":user },
    cache: false,
    success: function(response){
      $('#editar_tarefa_modal .modal-dialog').html(response);
      $('.select').select2({ width: '100%'});
    }
  });
});

// Criar Tarefa
$(document).on("click", ".botao_criar_tarefa", function()
{
  var tarestadoid = $(this).data('tarestadoid');
  var user = $(this).data('user');

  console.log("user: " + user + ";" + "tarestadoid: " + tarestadoid);

  $.ajax({
    url: '/app/elements/functions/ajax.php',
    type: 'POST',
    data: {"ajax":"criar_tarefa", "tarestadoid":tarestadoid, "user":user },
    cache: false,
    success: function(response) {
      $('#criar_tarefa_modal_2 .modal-dialog').html(response);
      $('.select').select2({ width: '100%' });
    }
  });
});

// Botão Atualizar
$(document).on("click", ".atualiza_BTN", function()
{
  var tabela_taskboard = document.getElementById("tabela_taskboard");
  var userid = tabela_taskboard.getAttribute("data-userid");
  document.getElementById("botao_filtro_default").setAttribute("userid", userid);
  document.getElementById("botao_filtro_default").style.display = 'none';
  var projetos = "";
  var clientes = ""; // Inicializa a variavel com '*' para selecionar todos, por default
  var users = "";
  var estados = "";
  var seguidores = "";

  // Vai buscar os valores do filtro Projetos
  $('#filtro_projetos :selected').each(function(){
    projetos += this.value + " ";
  });

  // Vai buscar os valores do filtro Users
  $("#filtro_users :selected").each(function() {
    users += this.value + " ";
  });

  // Vai buscar os valores do filtro Estados
  $("#filtro_estados :selected").each(function(){
    estados += this.value + " ";
  });

  // Vai buscar os valores do filtro Clientes
  $("#filtro_clientes :selected").each(function(){
    clientes += this.value + " ";
  });

  // Vai buscar o valor dos estado do botão 'Tarefas a Seguir'/'Minhas Tarefas'
  botao_mostrar_seguidores = document.getElementById("botao_mostrar_seguidores");
  seguidores = botao_mostrar_seguidores.getAttribute("data-veraseguir");

  // Determina se mostra o botão de reset filtro de User
  btnfiltro_default = document.getElementById("botao_filtro_default");
  userid = btnfiltro_default.getAttribute("userid");
  if (users.trim() != userid) {
    btnfiltro_default.style.display = "inline-block";
  }
  else {
    btnfiltro_default.style.display = "none";
  }

  var tabela_taskboard = document.getElementById("tabela_taskboard");
  var userid = users;
  var estadosid = estados;
  var userpermissoes = tabela_taskboard.getAttribute("data-userpermissoes");

  // Inicia o Loading
  $("body").addClass("loading");

  // Limpa o conteúdo atual da tabela Taskboard
  $('#tabela_taskboard .card-body').innerHTML = "";

  // Carrega novamente a Tabela taskboard
  $.ajax({
    url: '/app/elements/functions/ajax.php',
    type: 'POST',
    data: {"ajax":"carregar_taskboard", "userid": userid, "userpermissoes": userpermissoes, "estadosid":estadosid, "projetos":projetos, "clientes":clientes, "seguidores": seguidores},
    cache: false,
    success: function(response){
      $('#tabela_taskboard .card-body').html(response);
      // Volta a inicializar o Sortable depois de carregar a Tabela em ajax
      $(".kanban-wrap").sortable({
        connectWith: ".kanban-wrap",
        handle: ".kanban-box",
        placeholder: "drag-placeholder"
      });
      // Retira o Loading ao finalizar
      $("body").removeClass("loading");
    }
  });
});

  // Eliminar Tarefa
  $(document).on('click', '.botao_eliminar_tarefa', function()
  {
    var nometarefa = $(this).data('nometarefa');
    var tarefaid = $(this).data('tarefaid');
    $.ajax({
      url: '/app/elements/functions/ajax.php',
      type: 'POST',
      data: {"ajax":"eliminar_tarefa_modal", "nometarefa":nometarefa, "tarefaid":tarefaid },
      cache: false,
      success: function(response){
        $('#eliminar_tarefa_modal .modal-dialog').html(response);
      }
    });
  });


  // On SortReceive do Sortable UI
  $(document).on("sortreceive", ".selector", function(e, ui) {
    var tarestadoid = $(this).data('estadoid');
    var tarefaid = ui.item.data('tarefaid');
    var projetos = "*"; // Inicializa a variavel com '*' para selecionar todos, por default
    var clientes = "*"; // Inicializa a variavel com '*' para selecionar todos, por default

    var users = "";
    var estados = "";
    var seguidores = "";
    $("#filtro_users :selected").each(function() {
      users += this.value + " ";
    });

    // Vai buscar os valores do filtro Estados
    $("#filtro_estados :selected").each(function(){
      estados += this.value + " ";
    });

    var tabela_taskboard = document.getElementById("tabela_taskboard");
    var userid = users;
    var estadosid = estados;
    var userpermissoes = tabela_taskboard.getAttribute("data-userpermissoes");



    $.ajax({
      url: '/app/elements/functions/ajax.php',
      type: 'POST',
      data: {"ajax":"salvar_estado", "tarestadoid" : tarestadoid, "tarefaid" : tarefaid},
      success: function(response){
        var progressBar =$.ajax({
          url: '/app/elements/functions/ajax.php',
          type: 'POST',
          data: {"ajax":"carregar_progressbar", "userid": userid, "userpermissoes": userpermissoes, "estadosid": estadosid, "projetos": projetos, "clientes":clientes, "seguidores": seguidores},
          cache: false,
          async:true,
        }).responseText;
        $(".progress").empty().append(progressBar);
      }

    });
  });

  var tarefasordenacaoarray = new Array();
  var indicearray;
  $(document).on( "sortupdate",".selector", function( e, ui ) {
    var tarefaestadoid = $(this).parent().data('tarestadoid');

    $(".tarefaestadoid"+tarefaestadoid+" .card.panel").each(function( index )
    {
      tarefasordenacaoarray[index] = $(this).data("tarefaid");
      //console.log( tarefaestadoid + ": " +index + ": " + $(this).data("tarefaid") );
    });
    //console.log(tarefasordenacaoarray);
    $.ajax({
      url: "/app/elements/functions/actions.php",
      type: 'POST',
      data: {"acao": "tarefas_ordenacao_taskboard", "tarestadoid" : tarefaestadoid, "tarefasordenacaoarray": tarefasordenacaoarray},
      cache: false,
    });
  } );




  // Click botao seleccionar 'Ver Todos/Limpar Filtros'
  $(document).on("click", ".botao_ver_todos", function() {
    var userid = $(this).data('userid');

    selectElement = document.getElementById("filtro_users");
    var options = selectElement.options;
    for (var i = 0, optionsLength = options.length; i < optionsLength; i++) {
      if (options[i].value == userid) {
        selectElement.selectedIndex = i;
      }
    }
    $('#filtro_users').trigger("change");
  });

  // Click botao 'Mostrar Filtros'/'Esconder Filtros'
  $(document).on("click", ".botao_mostrar_filtros", function() {
    var filtro_users = document.getElementById("container_filtros");
    var botao_mostrar_filtros = document.getElementById("botao_mostrar_filtros");

    if (botao_mostrar_filtros.innerHTML == '<i class="fa fa-angle-down"></i>Mostrar Filtros') {
      botao_mostrar_filtros.innerHTML = '<i class="fa fa-angle-up"></i>Esconder Filtros';
      filtro_users.style.display = "flex";
    }
    else {
      botao_mostrar_filtros.innerHTML = '<i class="fa fa-angle-down"></i>Mostrar Filtros';
      filtro_users.style.display = "none";
    }
  });

  // Click botao 'Mostrar Tarefas a Seguir'
  $(document).on("click", ".botao_mostrar_seguidores", function(){
    var botao_mostrar_seguidores = document.getElementById("botao_mostrar_seguidores");

    if (botao_mostrar_seguidores.innerHTML == '<i class="fa fa-users"></i>Tarefas a Seguir') {
      botao_mostrar_seguidores.innerHTML = '<i class="fa fa-user"></i>Minhas Tarefas';
      botao_mostrar_seguidores.setAttribute("data-veraseguir", "1");
    }
    else {
      botao_mostrar_seguidores.innerHTML = '<i class="fa fa-users"></i>Tarefas a Seguir';
      botao_mostrar_seguidores.setAttribute("data-veraseguir", "0");
    }
    $('#filtro_users').trigger("change");
  });

  // Ao carregar a página (taskboard.php)
  document.addEventListener("DOMContentLoaded", function() {
    var tabela_taskboard = document.getElementById("tabela_taskboard");
    var userid = tabela_taskboard.getAttribute("data-userid");
    document.getElementById("botao_filtro_default").setAttribute("userid", userid);
    document.getElementById("botao_filtro_default").style.display = 'none';
    var projetos = document.getElementById('filtro_projetos').getAttribute('data-filtrodefault');
    console.log(projetos);
    //var projetos = "*"; // Inicializa a variavel com '*' para selecionar todos, por default
    var clientes = "*"; // Inicializa a variavel com '*' para selecionar todos, por default

    var users = "";
    var estados = "";
    var seguidores = "";

    // Vai buscar os valores do filtro Users
    $("#filtro_users :selected").each(function() {
      users += this.value + " ";
    });

    // Vai buscar os valores do filtro Estados
    $("#filtro_estados :selected").each(function() {
      estados += this.value + " ";
    });

    //console.log("Users seleccionados: " + users);

    // Vai buscar o valor dos estado do botão 'Tarefas a Seguir'/'Minhas Tarefas'
    botao_mostrar_seguidores = document.getElementById("botao_mostrar_seguidores");
    seguidores = botao_mostrar_seguidores.getAttribute("data-veraseguir");

    // Determina se mostra o botão de reset filtro de User
    btnfiltro_default = document.getElementById("botao_filtro_default");
    userid = btnfiltro_default.getAttribute("userid");
    if (users.trim() != userid) {
      btnfiltro_default.style.display = "inline-block";
    }
    else {
      btnfiltro_default.style.display = "none";
    }

    var tabela_taskboard = document.getElementById("tabela_taskboard");
    var userid = users;
    var estadosid = estados;
    var userpermissoes = tabela_taskboard.getAttribute("data-userpermissoes");


    //Encolhe o menu lateral para maior area de visualização
    $('body').addClass("mini-sidebar");

    // O filtro clientes controla o filtro projetos. Consoante o cliente selecionado no filtro,
    // o filtro de projetos muda o conteúdo do filtro
    $.ajax({
      url: '/app/elements/functions/actions.php',
      type: 'POST',
      data: {"acao":"seleccionar_cliente", "clientes": clientes, "projetos": projetos},
      cache: false,
      success: function(response){
        $('#container_filtros .filtro_projetos').html(response);
      }
    });

    $("body").addClass("loading"); // Ativa a animacao Loading
    // Carrega a Tabela taskboard
    $.ajax({
      url: '/app/elements/functions/ajax.php',
      type: 'POST',
      data: {"ajax":"carregar_taskboard", "userid": userid, "userpermissoes": userpermissoes, "estadosid":estadosid, "projetos":projetos, "clientes":clientes, "seguidores": seguidores},
      cache: false,
      success: function(response){
        $('#tabela_taskboard .card-body').html(response);

        // Volta a inicializar o Sortable depois de carregar a Tabela em ajax
        $(".kanban-wrap").sortable({
          connectWith: ".kanban-wrap",
          handle: ".kanban-box",
          placeholder: "drag-placeholder"});
        }
      });


      //atualiza cards
      $(document).on("click", ".botao_atualiza", function(e, ui) {
        var tarestadoid = $(this).data('estadoid');
        //var tarefaid = ui.item.data('tarefaid');
        var projetos = ""; // Inicializa a variavel com '*' para selecionar todos, por default
        var clientes = ""; // Inicializa a variavel com '*' para selecionar todos, por default
        var users = "";
        var estados = "";
        var seguidores = "";
        $("#filtro_users :selected").each(function() {
          users += this.value + " ";
        });

        // Vai buscar os valores do filtro Estados
        $("#filtro_estados :selected").each(function(){
          estados += this.value + " ";
        });

        // Vai buscar os valores do filtro Projetos
        $('#filtro_projetos :selected').each(function(){
          projetos += this.value + " ";
        });

        // Vai buscar os valores do filtro Clientes
        $("#filtro_clientes :selected").each(function(){
          clientes += this.value + " ";
        });
        //se os clientes nao tiverem nada mete todos
        if(clientes.length == 0){
          clientes = "*";
        }
        //se os projetos nao tiverem nada mete todos
        if(projetos.length == 0){
          projetos = "*";
        }

        var tabela_taskboard = document.getElementById("tabela_taskboard");
        var userid = users;
        var estadosid = estados;
        var projetos = projetos;
        var clientes = clientes;
        var userpermissoes = tabela_taskboard.getAttribute("data-userpermissoes");

        $.ajax({
          url: '/app/elements/functions/ajax.php',
          type: 'POST',
          data: {"ajax":"carregar_taskboard", "userid": userid, "userpermissoes": userpermissoes, "estadosid":estadosid, "projetos":projetos, "clientes":clientes, "seguidores": seguidores},
          cache: false,
          success: function(response){
            $('#tabela_taskboard .card-body').html(response);

            // Volta a inicializar o Sortable depois de carregar a Tabela em ajax
            $(".kanban-wrap").sortable({
              connectWith: ".kanban-wrap",
              handle: ".kanban-box",
              placeholder: "drag-placeholder"});
            }

          });
        });


        // Carrega a Progress Bar
        $.ajax({
          url: '/app/elements/functions/ajax.php',
          type: 'POST',
          data: {"ajax":"carregar_progressbar", "userid": userid, "userpermissoes": userpermissoes, "estadosid": estadosid, "projetos": projetos, "clientes":clientes, "seguidores": seguidores},
          cache: false,
          success: function(response){
            $('#barra_progresso .progress').html(response);
            $("body").removeClass("loading"); // Remove a animacao Loading
          }
        });
      });

      // On Change, do Select
      $('select').on('change', function() {

        var users = "";
        var estados = "";
        var projetos = "";
        var clientes = "";
        var seguidores = "";

        // Vai buscar os valores do filtro Projetos
        $('#filtro_projetos :selected').each(function(){
          projetos += this.value + " ";
        });

        // Vai buscar os valores do filtro Users
        $("#filtro_users :selected").each(function() {
          users += this.value + " ";
        });

        // Vai buscar os valores do filtro Estados
        $("#filtro_estados :selected").each(function(){
          estados += this.value + " ";
        });

        // Vai buscar os valores do filtro Clientes
        $("#filtro_clientes :selected").each(function(){
          clientes += this.value + " ";
        });

        // Vai buscar o valor dos estado do botão 'Tarefas a Seguir'/'Minhas Tarefas'
        botao_mostrar_seguidores = document.getElementById("botao_mostrar_seguidores");
        seguidores = botao_mostrar_seguidores.getAttribute("data-veraseguir");

        // Determina se mostra o botão de reset filtro de User
        btnfiltro_default = document.getElementById("botao_filtro_default");
        userid = btnfiltro_default.getAttribute("userid");
        if (users.trim() != userid) {
          btnfiltro_default.style.display = "inline-block";
        }
        else {
          btnfiltro_default.style.display = "none";
        }

        var tabela_taskboard = document.getElementById("tabela_taskboard");
        var userid = users;
        var estadosid = estados;
        var userpermissoes = tabela_taskboard.getAttribute("data-userpermissoes");

        // O filtro clientes controla o filtro projetos. Consoante o cliente selecionado no filtro,
        // o filtro de projetos muda o conteúdo do filtro
        $.ajax({
          url: '/app/elements/functions/actions.php',
          type: 'POST',
          data: {"acao":"seleccionar_cliente", "clientes": clientes, "projetos": projetos},
          cache: false,
          success: function(response){
            $('#container_filtros .filtro_projetos').html(response);
          }
        });

        $("body").addClass("loading");
        $.ajax({
          url: '/app/elements/functions/ajax.php',
          type: 'POST',
          data: {"ajax":"carregar_taskboard", "userid": userid, "userpermissoes": userpermissoes, "estadosid": estadosid, "projetos": projetos, "clientes": clientes, "seguidores": seguidores},
          cache: false,
          success: function(response) {
            $('#tabela_taskboard .card-body').html(response);

            // Volta a inicializar o SortableUI  depois de carregar a Tabela em ajax
            $(".kanban-wrap").sortable({
              connectWith: ".kanban-wrap",
              handle: ".kanban-box",
              placeholder: "drag-placeholder"});
            }
          });

          $.ajax({
            url: '/app/elements/functions/ajax.php',
            type: 'POST',
            data: {"ajax":"carregar_progressbar", "userid": userid, "userpermissoes": userpermissoes, "estadosid": estadosid, "projetos": projetos, "clientes": clientes, "seguidores": seguidores, "seguidores": seguidores},
            cache: false,
            success: function(response){
              $('#barra_progresso .progress').html(response);
              $("body").removeClass("loading"); // Remove a animacao Loading
            }
          });
        });

        $(document).on("click input keyup hover change", "#estilobtn", function(){//A DESCONTINUAR
          console.log("entrou");
          var state = $(this).val();
          $(".board-control.board-Array").css("background-color",state);
        });
